﻿# 管理者かどうかを返す
function TestAdministrator {
    $currentPrincipal = New-Object Security.Principal.WindowsPrincipal( [Security.Principal.WindowsIdentity]::GetCurrent() )
    return $currentPrincipal.IsInRole( [Security.Principal.WindowsBuiltInRole]::Administrator )
}

# クライアントOSかどうか判定する
function IsClientOS {
    param ()

    $os = Get-WmiObject -Class Win32_OperatingSystem

    if ($os.ProductType -eq 1) {
        # ProductType が 1 の場合はクライアント OS
        return $true
    } else {
        return $false
    }
}

function Write-Result {
    param (
        [parameter(mandatory = $true)][string]$item,
        [parameter(mandatory = $true)][bool]$isSuccess
    )
    Write-Host $item  -NoNewline
    if ($isSuccess) {
        Write-Result-Success
    } else {
        Write-Result-Error
    }
}

# 結果表示で色を変えて出力する
function Write-Result-Error() {
    Write-Host "[" -NoNewline
    Write-Host "NG" -NoNewline -ForegroundColor Red
    Write-Host "] "
}

function Write-Result-Success() {
    Write-Host "[" -NoNewline
    Write-Host "OK" -NoNewline -ForegroundColor Green
    Write-Host "] "
}

# エラー出力
function Write-Error {
    param (
        # 出力メッセージ
        [parameter(mandatory = $true)]$msg
    )

    Write-Host $msg -ForegroundColor Red
}