﻿$here = Split-Path -Parent $MyInvocation.MyCommand.Path
. "$here\Registry.ps1"

#UACが有効かどうかを返す
#状態により2パターンある
#http://winkit.blog.fc2.com/blog-entry-39.html
function Get-UACEnabled {
    $regPath = "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System"

    # グループポリシーで無効か状態
    # コンピューターの構成 -> セキュリティ設定 -> ローカルポリシー -> セキュリティオプション
    # ユーザーアカウント制御：管理者承認モードですべての管理者を実行する -> 無効
    $enableLUA_Name = "EnableLUA"
    $enableLUA_Value = Get-RegistryValue $regPath $enableLUA_Name

    if ($enableLUA_Value -eq 0) {
        return $false
    }

    # GUIから無効化した場合のチェック
    $ConsentPromptBehaviorAdmin_Name = "ConsentPromptBehaviorAdmin"
    $PromptOnSecureDesktop_Name = "PromptOnSecureDesktop"

    $ConsentPromptBehaviorAdmin_Value = Get-RegistryValue $regPath $ConsentPromptBehaviorAdmin_Name
    $PromptOnSecureDesktop_Value = Get-RegistryValue $regPath $PromptOnSecureDesktop_Name

    If ($ConsentPromptBehaviorAdmin_Value -eq 0 -And $PromptOnSecureDesktop_Value -eq 0) {
        return $false
    }

    return $true
}
